# lumi-g-test

Simple MPI-tool to check sanity of LUMI-G environment at runtime. Testcase is:
- MPI application with 8 MPI ranks (equal to number of GPUs on a node)
- OpenMP cycles use 8 or 7 threads depending on the NUMA node (first NUMA node on LUMI-G has 
an OS-dedicated core that is excluded)
- uses `hip` for GPU-based tests

We check that: 
- build is OK;
- environment setting and runtime configuration is OK; 
- bandwidth charachteristics on 2 nodes are OK.

What we do at runtime:
- print CPU core affinity info for each rank, for each thread in OpenMP region
- print GPU affinity info for each rank
- print NIC affinity info for each rank (?)
- STREAM test on GPU (per rank, on all cards simultaneously)
- Bandwidth H2D/D2H test for GPUs (per rank, on all cards simultaneously)
- Bandwidth of MPI p2p exchanges on GPU memory (per rank, on all cards simultaneously)


