#include "alloc.h"
#include "defs.h"

namespace sys {

char *gpu_alloc(size_t size) {
    char *ptr;
    HIP_CALL(hipMalloc((void**)&ptr, size));
    HIP_CALL(hipMemset(ptr, 0, sizeof(size)));
    return ptr;
}

void gpu_free(void *ptr) {
    HIP_CALL(hipFree(ptr));
}

char *cpu_alloc_pinned(size_t size) {
    char *ptr;
    HIP_CALL(hipHostMalloc(&ptr, size, 0));
    return ptr;
}

void cpu_free_pinned(void *ptr) {
    HIP_CALL(hipHostFree(ptr));
}

char *cpu_alloc_pageable(size_t size) {
    char *ptr;
    ptr = (char *)calloc(size, 1);
    return ptr;
}

void cpu_free_pageable(void *ptr) {
    free(ptr);
}

}

